﻿#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=prog.ico
#AutoIt3Wrapper_Outfile=IconShow.exe
#AutoIt3Wrapper_Outfile_x64=IconShow64.exe
#AutoIt3Wrapper_Compile_Both=y
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Res_Description=Icon-Show
#AutoIt3Wrapper_Res_Fileversion=1.1.0.0
#AutoIt3Wrapper_Res_ProductName=Icon-Show
#AutoIt3Wrapper_Res_ProductVersion=1.1.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <AutoItConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <GuiImageList.au3>
#include <GuiListView.au3>
#include <GuiMenu.au3>
#include <ListViewConstants.au3>
#include <Math.au3>
#include <StringConstants.au3>
#include <StructureConstants.au3>
#include <WinAPIGdi.au3>
#include <WinAPIHObj.au3>
#include <WinAPIIcons.au3>
#include <WinAPIShellEx.au3>
#include <WindowsConstants.au3>

Global Const $sAppTitle = 'Icon-Show'
Global Const $sAppVersion = '1.1.0.0'
Global Const $sAppDate = '31.08.2018'
Global Const $sAppAuthor = 'Oscar (www.autoit.de)'
Global $iIconSize = 64
Global $sPath = @SystemDir & '\imageres.dll'
Global $sSelPath, $aSelIndices, $sSelItems, $sSelSize, $hBitmap, $hIcon
Global $hImgList = _GUIImageList_Create($iIconSize, $iIconSize, 5)

Global $hGui = GUICreate(StringFormat('%s  -  v%-3.3s  -  © 2018 by %s', $sAppTitle, $sAppVersion, $sAppAuthor), 800, 600, -1, -1, $WS_OVERLAPPEDWINDOW)
GUISetFont(12, 400, 0, 'Verdana')

Global $sCommonDLLs = 'imageres.dll|shell32.dll|ddores.dll|dmdskres.dll|comres.dll|' & _
		'ieframe.dll|netshell.dll|wmploc.dll|wpdshext.dll|pnidui.dll|' & _
		'Dsuiext.dll|inetcpl.cpl|urlmon.dll|wiashext.dll|setupapi.dll|' & _
		'mmres.dll|compstui.dll|mmcndmgr.dll|pifmgr.dll'
GUICtrlCreateLabel('Common DLLs:', 16, 15, 130, 20)
GUICtrlSetResizing(-1, 512 + 256 + 32 + 2)
Global $idPathSelect = GUICtrlCreateCombo('', 150, 10, 160, 25, $CBS_DROPDOWNLIST)
GUICtrlSetResizing(-1, 512 + 256 + 32 + 2)
GUICtrlSetData($idPathSelect, $sCommonDLLs, 'imageres.dll')

Global $sCommonSize = '24 px|32 px|48 px|64 px|96 px|128 px|160 px|256 px'
GUICtrlCreateLabel('Iconsize:', 620, 15, 90, 20)
GUICtrlSetResizing(-1, 512 + 256 + 32 + 4)
Global $idSeletIconSize = GUICtrlCreateCombo('', 710, 10, 80, 25, $CBS_DROPDOWNLIST)
GUICtrlSetResizing(-1, 512 + 256 + 32 + 4)
GUICtrlSetData($idSeletIconSize, $sCommonSize, '64 px')

Global $idPath = GUICtrlCreateInput($sPath, 10, 45, 740, 25, BitOR($ES_LEFT, $ES_AUTOHSCROLL, $ES_READONLY))
GUICtrlSetResizing(-1, 512 + 32 + 4 + 2)
GUICtrlSetBkColor(-1, 0xFFFFFF)

Global $idSelect = GUICtrlCreateButton('...', 755, 45, 35, 25)
GUICtrlSetResizing(-1, 512 + 256 + 32 + 4)

Global $idListView = GUICtrlCreateListView('', 5, 80, 790, 515, $LVS_REPORT, $WS_EX_CLIENTEDGE)
GUICtrlSetResizing(-1, 64 + 32 + 4 + 2)
GUICtrlSetStyle(-1, $LVS_SMALLICON)
Global $hListview = GUICtrlGetHandle($idListView)

Global $idContext = GUICtrlCreateContextMenu($idListView)
Global $idCopySelected = GUICtrlCreateMenuItem('Copy selected indices to clipboard (comma-separated)', $idContext)
Global $idExtractIcon = GUICtrlCreateMenuItem('Extract selected Icons as PNG-Files', $idContext)

Global $hContext = GUICtrlGetHandle($idContext)
Global $hClipboardIcon = _CreateMenuBitmap('shell32.dll', 260, 32)
Global $hExtractIcon = _CreateMenuBitmap('shell32.dll', 26, 32)
_GUICtrlMenu_SetItemBmp($hContext, 0, $hClipboardIcon)
_GUICtrlMenu_SetItemBmp($hContext, 1, $hExtractIcon)

GUISetState()
GUIRegisterMsg($WM_SIZE, '_WM_SIZE')
GUIRegisterMsg($WM_NOTIFY, '_WM_NOTIFY')
_LoadIcons($hListview, $hImgList, $sPath)

While True
	Switch GUIGetMsg()
		Case $GUI_EVENT_CLOSE
			_WinAPI_DeleteObject($hExtractIcon)
			_WinAPI_DeleteObject($hClipboardIcon)
			_GUIImageList_Destroy($hImgList)
			Exit
		Case $GUI_EVENT_MAXIMIZE
			_GUICtrlListView_Arrange($hListview, 2)
		Case $idPathSelect
			$sSelPath = GUICtrlRead($idPathSelect)
			If StringRight($sPath, StringLen($sSelPath)) <> $sSelPath Then
				$sPath = @SystemDir & '\' & $sSelPath
				GUICtrlSetData($idPath, $sPath)
				_LoadIcons($hListview, $hImgList, $sPath)
			EndIf
		Case $idSeletIconSize
			$sSelSize = GUICtrlRead($idSeletIconSize)
			$iIconSize = Number(StringTrimRight($sSelSize, 3))
			_LoadIcons($hListview, $hImgList, $sPath)
		Case $idSelect
			$sSelPath = FileOpenDialog('Select the Image-DLL', @SystemDir, 'Dll (*.dll)', 3, 'imageres.dll', $hGui)
			If Not @error Then
				$sPath = $sSelPath
				GUICtrlSetData($idPath, $sPath)
				_LoadIcons($hListview, $hImgList, $sPath)
			EndIf
		Case $idCopySelected
			$aSelIndices = StringSplit(_GUICtrlListView_GetSelectedIndices($idListView), '|', $STR_NOCOUNT)
			$sSelItems = ''
			If IsArray($aSelIndices) Then
				For $iIndex In $aSelIndices
					$sSelItems &= $iIndex & ', '
				Next
				ClipPut(StringTrimRight($sSelItems, 2))
			EndIf
		Case $idExtractIcon
			$sSelPath = FileOpenDialog('Select a startfile (added indices)', @ScriptDir, 'PNG (*.png)', 2, StringRegExpReplace($sPath, '.+\\(.+)\.dll', '$1.png'), $hGui)
			If Not @error Then
				If StringRight($sSelPath, 4) <> '.png' Then $sSelPath &= '.png'
				_GDIPlus_Startup()
				$aSelIndices = StringSplit(_GUICtrlListView_GetSelectedIndices($idListView), '|', $STR_NOCOUNT)
				If IsArray($aSelIndices) Then
					For $iIndex In $aSelIndices
						$hIcon = _GUIImageList_GetIcon($hImgList, $iIndex)
						$hBitmap = _GDIPlus_BitmapCreateFromHICON32($hIcon)
						_GDIPlus_ImageSaveToFile($hBitmap, StringRegExpReplace($sSelPath, '(.+)\.png', '$1') & StringFormat('%03i.png', $iIndex))
						_GDIPlus_BitmapDispose($hBitmap)
						_GUIImageList_DestroyIcon($hIcon)
					Next
				EndIf
				_GDIPlus_Shutdown()
			EndIf
	EndSwitch
WEnd

Func _CreateMenuBitmap($sPath, $iIndex, $iIconSize)
	Local $hIcon = _WinAPI_ShellExtractIcon($sPath, $iIndex, $iIconSize, $iIconSize)
	Return _WinAPI_Create32BitHBITMAP($hIcon, True, True)
EndFunc   ;==>_CreateMenuBitmap

Func _WM_NOTIFY($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg, $wParam
	Local $tNMHDR, $hWndFrom, $tNMITEMACTIVATE, $iIndex
	$tNMHDR = DllStructCreate($tagNMHDR, $lParam)
	$hWndFrom = HWnd(DllStructGetData($tNMHDR, 'hWndFrom'))
	Switch $hWndFrom
		Case $hListview
			Switch DllStructGetData($tNMHDR, 'Code')
				Case $NM_DBLCLK
					$tNMITEMACTIVATE = DllStructCreate($tagNMITEMACTIVATE, $lParam)
					$iIndex = DllStructGetData($tNMITEMACTIVATE, 'Index')
					ClipPut(StringFormat("'%s', %i", StringRegExpReplace($sPath, '.+\\(.+)', '$1'), $iIndex))
					ToolTip('Copied DLL and Index to Clipboard', Default, Default, 'Icon-Show', $TIP_INFOICON, $TIP_BALLOON)
					AdlibRegister('_CloseToolTip', 2000)
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_NOTIFY

Func _WM_SIZE($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg, $wParam, $lParam
	_GUICtrlListView_Arrange($hListview, 2)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_SIZE

Func _CloseToolTip()
	AdlibUnRegister('_CloseToolTip')
	ToolTip('')
EndFunc   ;==>_CloseToolTip

Func _LoadIcons(ByRef $hListview, ByRef $hImgList, $sPath)
	Local $iIconCount, $hIcon, $hDIB, $iImgIndex
	_GUIImageList_Destroy($hImgList)
	ToolTip('Create icons! Please wait...', Default, Default, 'Icon-Show', $TIP_INFOICON, $TIP_BALLOON)
	_GUICtrlListView_BeginUpdate($hListview)
	_GUICtrlListView_DeleteAllItems($hListview)
	$iIconCount = _WinAPI_ExtractIconEx($sPath, -1, 0, 0, 0)
	$hImgList = _GUIImageList_Create($iIconSize, $iIconSize, 5, 0, $iIconCount)
	_GUICtrlListView_SetImageList($hListview, $hImgList, 1)
	For $i = 0 To $iIconCount - 1
		$hIcon = _WinAPI_ShellExtractIcon($sPath, $i, $iIconSize, $iIconSize)
		$hDIB = _WinAPI_Create32BitHBITMAP($hIcon, False)
		$iImgIndex = _GUIImageList_Add($hImgList, $hDIB)
		_WinAPI_DeleteObject($hDIB)
		_WinAPI_DestroyIcon($hIcon)
		_GUICtrlListView_AddItem($hListview, StringFormat('%03i', $i), $iImgIndex)
	Next
	_GUICtrlListView_EndUpdate($hListview)
	ToolTip('')
EndFunc   ;==>_LoadIcons
